from datetime import datetime
from typing import List, Optional, Dict, Any

from janis_core import *
from janis_core.types.common_data_types import Boolean, File

Falconc_M4Filt_V0_1_0 = CommandToolBuilder(tool="falconc_m4filt", base_command=["falconc", "m4filt"], inputs=[ToolInput(tag="in_help_syntax", input_type=Boolean(optional=True), prefix="--help-syntax", doc=InputDocumentation(doc="advanced: prepend,plurals,..")), ToolInput(tag="in__idtstage_float", input_type=Boolean(optional=True), prefix="-i", doc=InputDocumentation(doc="=, --idt-stage1=       float   90.0      Stage one percent identity filter,\nformatted as percentage, overlaps <\n%idt are skipped")), ToolInput(tag="in_idt_stage_two", input_type=Boolean(optional=True), prefix="--idt-stage2", doc=InputDocumentation(doc="=            float   90.0      Stage two percent identify filter")), ToolInput(tag="in_minlen_int_minimum", input_type=Boolean(optional=True), prefix="-m", doc=InputDocumentation(doc="=, --min-len=          int     6000      Minimum read length, reads shorter\nthan minLen will be discarded")), ToolInput(tag="in_min_cov", input_type=Boolean(optional=True), prefix="--min-cov", doc=InputDocumentation(doc="=               int     2         Minimum number of overlaps on\neither side of a read")), ToolInput(tag="in_max_cov", input_type=Boolean(optional=True), prefix="--max-cov", doc=InputDocumentation(doc="=               int     200       Maximum number of overlaps on\neither side of a read")), ToolInput(tag="in_max_diff", input_type=Boolean(optional=True), prefix="--max-diff", doc=InputDocumentation(doc="=              int     100       Reads are skipped is abs(5p-3p)\noverlap counts > maxDiff")), ToolInput(tag="in__bestn_int", input_type=Boolean(optional=True), prefix="-b", doc=InputDocumentation(doc="=, --bestn=            int     10        Keep N best overlaps at 5prime AND\n3prime of a read")), ToolInput(tag="in_min_overhang", input_type=Boolean(optional=True), prefix="--min-overhang", doc=InputDocumentation(doc="=          int     0         Minimum amount of overhang bases in\nan overlap to keep the overlap")), ToolInput(tag="in_min_depth", input_type=Boolean(optional=True), prefix="--min-depth", doc=InputDocumentation(doc="=             int     2         Depths lower than minDepth are\nconsidered gaps")), ToolInput(tag="in_gap_filt", input_type=Boolean(optional=True), prefix="--gap-filt", doc=InputDocumentation(doc="bool    false     Run depth filter, takes a little\nmore time")), ToolInput(tag="in_keep_intermediates", input_type=Boolean(optional=True), prefix="--keepIntermediates", doc=InputDocumentation(doc="bool    false     set keepIntermediates")), ToolInput(tag="in__nproc_int", input_type=Boolean(optional=True), prefix="-n", doc=InputDocumentation(doc="=, --n-proc=           int     24        Number of processes to run locally")), ToolInput(tag="in_in_fn", input_type=Boolean(optional=True), prefix="--in-fn", doc=InputDocumentation(doc="=                 string  REQUIRED  M4 overlaps file")), ToolInput(tag="in_filterlogfn_string_required", input_type=Boolean(optional=True), prefix="-f", doc=InputDocumentation(doc="=, --filter-log-fn=    string  REQUIRED  Write read filter stats to this")), ToolInput(tag="in_file", input_type=File(), position=0, doc=InputDocumentation(doc="-o=, --out-fn=           string  REQUIRED  Final m4 overlaps file"))], outputs=[], container=None, version="v0.1.0")


if __name__ == "__main__":
    # or "cwl"
    Falconc_M4Filt_V0_1_0().translate("wdl", allow_empty_container=True)

